import java.io.IOException;

/**
 * Displays a web site page or a file.
 * It needs a URL for the web site page or an absolute path for the file.
 * Example: "http://www.onomap.org" for a web site.
 */

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class BrowserControl {

    /** Sole constructor */
    public BrowserControl()  {}

    /**
     * Displays a web page or a file
     *
     * @param url   the web site address or an absolute path of a file
     */
    public static void displayURL(String url) {
        try {
            if (System.getProperty("os.name") != null &&
                    System.getProperty("os.name").startsWith("Windows")) {
                Process p = Runtime.getRuntime().exec(
                        ("rundll32 url.dll,FileProtocolHandler " + url));
            } else {
                // If the operating system is Unix, use Netscape.
                Process p = Runtime.getRuntime().exec(
                        "netscape -remote openURL(" + url + ")");
                try {

                    /**
                     * If the command fails, start the browser again without the
                     * the command "-remote".
                     */
                    if (p.waitFor() != 0) {
                        p = Runtime.getRuntime().exec(("netscape "  + url));
                    }
                } catch (InterruptedException e) {}
            }
        } catch (IOException e) {}
    }
}