
import javax.swing.JOptionPane;

/**
 * A helper class to divide a comma delimitted line of text to individual partsframe dialog box that is placed at the center of the screen and has the
*/

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class CommaDivision
{
    private String csvLine;

    public CommaDivision(String csvLine)
    {
        this.csvLine = csvLine;
    }

    public String[] getLineParts()
    {
        //System.out.println(csvLine);
        String[] fields = csvLine.split(",");
        int counter = 0;

        /** examine every part */
        for (int i = 0; i < fields.length; i++)
        {
            boolean thePartContinues = false;

            /** the part starts with a quote */
            if (fields[i].length() != 0 && fields[i].startsWith("\""))
            {

                /** the part ends with a quote */
                if (fields[i].endsWith("\""))
                {

                    /** if the part ends with only one quote */
                    if (!fields[i].substring(0, fields[i].length() - 1).endsWith("\""))
                    {
                        fields[i] = fields[i].substring(1, fields[i].length() - 1);
                        //System.out.println("ok" + fields[i]);
                    }
                    else
                    {

                        /** the part ends with more than one quote */
                        int nrQuotes = 2;
                        boolean quotesToCount = true;
                        int temp = fields[i].length() - 2;

                        /** count with how many quotes the part ends with */
                        while (temp > 0 && quotesToCount)
                        {
                            if (fields[i].substring(0, temp).endsWith("\""))
                            {
                                nrQuotes++;
                                temp--;
                            }
                            else
                            {
                                quotesToCount = false;
                            }
                        }

                        /**
                         * in case the word ends with even number of quotes,
                         * the part doesn't continue
                         */
                        if (nrQuotes % 2 > 0 || temp == 0)
                        {
                            fields[i] = fields[i].substring(1, fields[i].length() - 1);
                        }
                        else
                        {
                            thePartContinues = true;
                        }
                    }
                }
                else
                {
                    thePartContinues = true;
                }
            }

            int nrDividedParts = 0;

            while (thePartContinues && (i + nrDividedParts) < (fields.length - 1))
            {

                nrDividedParts++;
                int nrOfQuotes = 0;
                String nextPart = fields[i + nrDividedParts];
                //System.out.println(fields[i + nrDividedParts]);
                boolean quotesToCount = true;
                int temp = nextPart.length();

                /** count with how many quotes the part ends with */
                while (temp > 0 && quotesToCount)
                {
                    if (nextPart.substring(0, temp).endsWith("\""))
                    {
                        nrOfQuotes++;
                        temp--;
                    }
                    else
                    {
                        quotesToCount = false;
                    }
                }

                if (nrOfQuotes % 2 > 0)
                {
                    //System.out.println(nrOfQuotes);
                    if (nrDividedParts == 1)
                    {
                        fields[i] = fields[i].substring(1, fields[i].length()) +
                                "," +
                                fields[i + 1].substring(0, fields[i + 1].length() - 1);
                    }
                    else if (nrDividedParts == 2)
                    {
                        fields[i] = fields[i].substring(1, fields[i].length()) +
                                "," + fields[i + 1] + "," +
                                fields[i + 2].substring(0, fields[i + 2].length() - 1);
                    }
                    else
                    {
                        fields[i] = fields[i].substring(1, fields[i].length());

                        for (int j = 1; j < nrDividedParts; j++)
                        {
                            fields[i] = "," + fields[i] + fields[i + nrDividedParts];
                        }

                        fields[i] = fields[i] + "," + fields[i + nrDividedParts].substring(0, fields[i + 1].length() - 1);
                    }
                    thePartContinues = false;
                }
            }

            if (thePartContinues && (i + nrDividedParts) >= (fields.length - 1))
            {
                JOptionPane.showMessageDialog(new ErrorFrame(),
                    "You can not continue further. Please change this record and start again:\n" +
                    csvLine, "Error Message", JOptionPane.ERROR_MESSAGE);
                System.exit(0);
            }

            if (nrDividedParts > 0)
            {

                for (int j = 1; j < (fields.length - i - nrDividedParts); j++)
                {
                    fields[i + j] = fields[i + j + nrDividedParts];
                }

                String[] result = new String[fields.length - nrDividedParts];
                System.arraycopy(fields, 0, result, 0, fields.length - nrDividedParts);
                fields = result;
            }

            /**
             * in case there are quotes in the boddy of the line part.
             * In the csv files the quotes are multiplied
             */
            if (fields[i].indexOf("\"") > -1)
            {
                int tempCounter = 0;

                while (counter < fields[i].length())
                {
                    if(fields[i].charAt(counter) == '\"')
                    {
                        fields[i] = fields[i].substring(0, counter) +
                                fields[i].substring(counter + 1, fields[i].length());
                    }
                    counter++;
                }
            }
        }

        return fields;
    }
}
