import javax.swing.JFrame;
import javax.swing.UIManager;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.Toolkit;
import java.awt.Dimension;

/**
 * A frame dialog box that is placed at the center of the screen and has the
 * feel and look of the system.
 */

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class ErrorFrame extends JFrame
{

	private static final long serialVersionUID = 10024;

    /** the width of the frame */
    public static final int WIDTH = 100;

    /** the height of the frame */
    public static final int HEIGHT = 100;

    /**
     * Constructor
     */

    public ErrorFrame()
    {
       try
       {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
       } catch (Exception e){}

        setSize(WIDTH, HEIGHT);
        setTitle("Error Message");
        centreFrame();

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

    /**
     * Places the frame at centre of screen.
     */
    public void centreFrame ()
    {

        //The toolkit will get information of the system.
        Toolkit toolkit = Toolkit.getDefaultToolkit();

        // Get the screen dimensions.
        Dimension screen = toolkit.getScreenSize();

        // And place it in center of screen.
        int x = (int) ((screen.getWidth() - WIDTH)/2);
        int y = (int) ((screen.getHeight() - HEIGHT)/2);
        setLocation(x, y);
    }
}
