import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JFrame;
import java.awt.Toolkit;
import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.Color;
import javax.swing.JProgressBar;
import javax.swing.JTextArea;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.GridBagLayout;
import java.io.IOException;
import javax.swing.JOptionPane;
import java.awt.BorderLayout;
import java.util.Map;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.FileReader;

/**
 * A frame for reading the users' postcode file
 */

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class FileWaitPanel extends JPanel implements Runnable
{

	private static final long serialVersionUID = 10025;

    private Screen parent;

    public static int totalRecords;

    public static Map<String,String> lookup;

    /**  */
    private ReadFile file;

    /**  */
    private String filePath;

    /**  */
    private int nrLoadPanels;

    /**  */
    private JProgressBar progressBar;

    /**  */
    private javax.swing.Timer activityMonitor;

    /**  */
    private boolean taskFinished;

    /**  */
    private static final int DELAY = 500;

    /**  */
    public static boolean isProblematicFile;

    /**  */
    private int selectedCountry;

    /**  */
    private static int nrSelectedCountries[] = {0, 0};


     /*Constructor*/
    public FileWaitPanel(Screen parent, ReadFile file, String filePath,int nrLoadPanels)
    {

        setOpaque(true);
        setBackground(Color.WHITE);
        setLayout(new GridBagLayout());

        this.parent = parent;
        this.file = file;
        this.filePath = filePath;
        this.nrLoadPanels = nrLoadPanels;
        this.selectedCountry = 0;
        taskFinished = false;
        isProblematicFile = false;

        JLabel center = new JLabel("Please, wait a few seconds...");

        progressBar = new JProgressBar();
        progressBar.setIndeterminate(true);

        activityMonitor = new Timer(DELAY, new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                if(taskFinished) {
                    activityMonitor.stop();
                }
            }
        });

        new Thread(FileWaitPanel.this).start();
        activityMonitor.start();

        add(center, new GBC(0, 1).setInsets(50, 30, 20, 30));
        add(progressBar, new GBC(0, 2).setInsets(20, 30, 20, 30));
    }

    /*This function reads the users' postcode file*/
    public void run()
    {
        try
        {
            ReadUserFile userFile;
            userFile = new ReadUserFile(filePath);
            userFile.read();

            file = new ReadFile(0);

            BufferedReader br=new BufferedReader(new FileReader(filePath));

            int records=0;

			while ((br.readLine()) != null)
			{

              records++;


            }

            totalRecords=records;

            br.close();

           lookup = new HashMap<String, String>(1700000);
		   BufferedReader brs=new BufferedReader(new FileReader("csvFiles/Lookup.csv"));

		   String temp = "";
		   String[] ret = new CommaDivision(brs.readLine()).getLineParts();
		   int counter = 0;

		    while ((temp = brs.readLine()) != null)
		    {
		   	  ret = new CommaDivision(temp).getLineParts();
		   	  lookup.put(ret[0], ret[1]);
		   	  counter++;
            }


            removeAll();
            validate();
            parent.getContentPane().removeAll();

            //Once the file is read, display the first 50 records
            parent.add("North", new LogoPanel("images/logo.bmp"));
            parent.getContentPane().add(new ProcessTablePanel(parent, file,userFile.getFileName(), userFile.getFirstFiftyRecords(),userFile.getFileHeaders()));
            parent.setSize(Screen.BIG_SCREEN_WIDTH, Screen.BIG_SCREEN_HEIGHT);
            parent.setSize(600,500);
            parent.centerFrame();

            parent.validate();

        }
        catch (IOException e)
        {
			System.out.println("Here1" + e);
		}

        taskFinished = true;
    }
}