import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.File;
import java.io.InputStreamReader;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.util.Vector;
import java.util.Map;
import java.util.Iterator;
import java.util.Date;
import java.text.NumberFormat;
import java.util.HashMap;
import java.io.FileReader;

/**
 * A helper class for searching postcodes for the corresponding lookup values
 * This file also calls WriteFile (class) to write the matched records to an output file
*/

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class FileWritePostcodes implements Runnable
{

    private int nrLinesWritten;

    private String readerName, writerName;

    private BufferedReader br1;

    private FileInputStream fis1;

    private WriteFile wf;

    private int[] indexes, columnNr, exportedCels;

    private boolean threadStop;

    private Vector inputFile=new Vector();
    private Vector inputFile1=new Vector();
    String firstLine="";




    public FileWritePostcodes(String filePath, String fileName) throws IOException
    {
        readerName = filePath;
        writerName = filePath;

        BufferedReader brs;
        String temp="";
        int counter=0;
        String[] ret;


        brs=new BufferedReader(new FileReader(fileName));

		temp = "";
		ret = new CommaDivision(brs.readLine()).getLineParts();
		counter = 0;


	    for(int i=0;i<ret.length;i++)
		 {
		  firstLine+=ret[i] + ",";
		 }

		while ((temp = brs.readLine()) != null)
		{

		 ret = new CommaDivision(temp).getLineParts();
		 inputFile.add(ret[IdentificationPanel.indexVal]);
		 String s1="";
		 for(int i=0;i<ret.length;i++)
		 {
		  s1+=ret[i] + ",";
		 }

		 try
		  {
		  s1=s1.substring(0,s1.length()-1);
	      }
	      catch(Exception e)
	      {
		  }

		 inputFile1.add(s1);

		 counter++;
        }

        nrLinesWritten=0;

        wf = new WriteFile(writerName);

    }

    public void setThreadStop(boolean value)
    {
        threadStop = value;
    }


    public void run()
    {
        try
        {
            writeFile();
        }
        catch(IOException e) {}
    }

   public int getLineNr()
	{
	    return nrLinesWritten;
    }



   /**
    * Match every record of users' postcode file with ONSPD, and write the output
    * This file calls WriteFile to write the matched records to an output file
   */
   public void writeFile() throws IOException
   {

	 wf.write(firstLine + "Super Group,Group,Subgroup,VALID\n");

    for(int i=0;i<inputFile.size();i++)
     {

       String pCode=(String)inputFile.get(i);
       pCode=pCode.replaceAll(" ","");

       String pCode1=(String)inputFile1.get(i);


       String val=FileWaitPanel.lookup.get(pCode);

        if(val==null)
        {
		   val="null";
	    }

       if(val.equals("null"))
       {

		 boolean b=pCode.matches("^([Gg][Ii][Rr] 0[Aa]{2})|((([A-Za-z][0-9]{1,2})|(([A-Za-z][A-Ha-hJ-Yj-y][0-9]{1,2})|(([A-Za-z][0-9][A-Za-z])|([A-Za-z][A-Ha-hJ-Yj-y][0-9]?[A-Za-z])))) {0,1}[0-9][A-Za-z]{2})$");

         if(b)
          {
		   wf.write("" + pCode1 + ",NOT FOUND,NOT FOUND,NOT FOUND,1\n");
	      }
	     else
	      {
		   wf.write("" + pCode1 + ",NOT FOUND,NOT FOUND,NOT FOUND,0\n");
		  }
	   }
	   else
	   {
		 boolean b=pCode.matches("^([Gg][Ii][Rr] 0[Aa]{2})|((([A-Za-z][0-9]{1,2})|(([A-Za-z][A-Ha-hJ-Yj-y][0-9]{1,2})|(([A-Za-z][0-9][A-Za-z])|([A-Za-z][A-Ha-hJ-Yj-y][0-9]?[A-Za-z])))) {0,1}[0-9][A-Za-z]{2})$");

         if(b)
          {

           wf.write("" + pCode1 + "," + val.substring(0,1) + "," + val.substring(0,2) + "," + val + ",1\n");

	      }
	     else
	      {
			 wf.write("" + pCode1 + "," + val.substring(0,1) + "," + val.substring(0,2) + "," + val + ",0\n");
		  }
       }

       nrLinesWritten ++;

	 }

   }


}
