
import java.awt.GridBagLayout;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JPanel;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.BorderFactory;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JTextField;
import java.io.File;


/**
 * A panel for the user to specify the name of the output file
 */

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class FinalPanel extends JPanel implements ActionListener
{

    private static final long serialVersionUID = 10022;

	private ReadFile readFiles;

	public static int indexVal=0;

	private int[] indexes;

	private int[] exportedCels;

	private JFileChooser chooser;

    private int[] columnNr;

    private Screen parent;

    private ReadFile rf;

    /** the name of the input file */
    private String fileName;

    /** the headers of the column file */
    private String[] fileHeaders;

    /** the first fifty records of the file */
    private String[][] fiftyRecords;

    /** the drop down menus containing the headers of the input file */
    private JComboBox[] comboBoxes;

    /** checkboxes for each of the possible import fields */
    private JCheckBox[] checkBoxes;

    private static int nrProcesses = 0;

    private String filePath;

    private static final int NR_IMPORT_FIELDS = 3;

    private static final int NR_MANDATORY_FIELDS = 2;


    JButton browse;
    JLabel info;
    JTextField fileField;

    public FinalPanel(Screen parent, ReadFile rf, String fileName,String[][] fiftyRecords, String[] fileHeaders)
      {


		for(int i=0;i<fileHeaders.length;i++)
		{
			String a=fileHeaders[i];
			String b=a;

			if(a.length()<50)
			 {
				 for(int j=a.length();j<=50;j++)
				  {
					  b+=" ";
				  }

			 }
			fileHeaders[i]=b;
		}

        setOpaque(true);
        setBackground(Color.WHITE);
        setLayout(null);

        this.parent = parent;
        this.rf = rf;
        this.fileName = fileName;
        this.fileHeaders = fileHeaders;
        this.fiftyRecords = fiftyRecords;

        parent.setSize(500,420);

        comboBoxes = new JComboBox[NR_IMPORT_FIELDS];
        checkBoxes = new JCheckBox[NR_IMPORT_FIELDS];

        ActionListener compute = new ComputeListener();
        ActionListener back = new BackListener();
        ActionListener br = new BrowseListener();


        columnNr = getIndexes(fileHeaders);

        for(int i = 0; i < NR_IMPORT_FIELDS; i++)
        {
            comboBoxes[i] = new JComboBox(fileHeaders);
            checkBoxes[i] = new JCheckBox();
            checkBoxes[i].addActionListener(this);
            checkBoxes[i].setOpaque(true);
            checkBoxes[i].setBackground(Color.WHITE);
        }

        JLabel label[] = new JLabel[NR_IMPORT_FIELDS];
        label[0] = new JLabel("Postcode:");

        for (int i = 0; i < 1; i++)
        {
            if (columnNr[i] > -1)
            {
                checkBoxes[i].setSelected(true);
                comboBoxes[i].setSelectedItem(fileHeaders[columnNr[i]]);
            }
            else
            {
                checkBoxes[i].setSelected(false);
                comboBoxes[i].setSelectedItem(null);
            }
        }


        for(int i = 0; i < 1; i++)
        {
            checkBoxes[i].setSelected(true);
        }

        JButton computeButton = new JButton(" Next >>");
        computeButton.addActionListener(compute);

        JButton backButton = new JButton("<< Back ");
        backButton.addActionListener(back);

        JLabel menu = new JLabel("Select Output File");
        menu.setFont(new Font("SansSerif", Font.BOLD, 20));

        menu.setBounds(140,10,400,50);
        add(menu);

        Font labelFont = new Font("SansSerif", Font.BOLD, 12);

        JLabel imp = new JLabel("");
        imp.setFont(labelFont);
        JLabel fn = new JLabel("");
        fn.setFont(labelFont);
        JLabel fcn = new JLabel("");
        fcn.setFont(labelFont);

        /////////////////
        chooser = new JFileChooser("");
        chooser.addChoosableFileFilter(new TextFileFilter());

		chooser.setDialogTitle("Specify the export file name and location.");
        /////////////////


        info=new JLabel("Specify the output:");
        fileField=new JTextField(20);
        browse=new JButton("Browse");

        info.setBounds(30,140,120,20);
		add(info);

		fileField.setBounds(140,140,200,20);
		add(fileField);

		browse.addActionListener(br);

		browse.setBounds(350,140,80,20);
        add(browse);

        JPanel hyperlinksPanel = new JPanel();
        hyperlinksPanel.setOpaque(true);
        hyperlinksPanel.setBackground(Color.WHITE);

        backButton.setBounds(240,240,80,20);
        add(backButton);

        computeButton.setBounds(370,240,80,20);
        add(computeButton);

    }

    public void actionPerformed(ActionEvent event)
    {
        JCheckBox e = (JCheckBox) event.getSource();

        for(int i = 0; i < NR_MANDATORY_FIELDS; i++)
        {
            if (e == checkBoxes[i])
            {
                e.setSelected(true);
                JOptionPane.showMessageDialog(new ErrorFrame(), "This field is mandatory.", "Warning message", JOptionPane.WARNING_MESSAGE);
            }
        }
    }


    private class BackListener implements ActionListener
    {

        public void actionPerformed(ActionEvent event)
        {
            removeAll();
            validate();
            parent.getContentPane().removeAll();
            parent.add(BorderLayout.NORTH, new LogoPanel("images/logo.bmp"));
            parent.getContentPane().add(new IdentificationPanel(parent, rf,fileName, fiftyRecords, fileHeaders));
            parent.centerFrame();
            parent.validate();
        }
    }

    private class ComputeListener implements ActionListener
    {

        public void actionPerformed(ActionEvent event)
        {
            goToNextPanel();
        }
    }

    private class NextMouseListener extends MouseAdapter
    {

        public void mouseClicked(MouseEvent event)
        {
            goToNextPanel();
        }
    }

    private class BrowseListener implements ActionListener
    {

	        public void actionPerformed(ActionEvent event)
	        {
	            browseFile();
	        }
    }


    public void browseFile()
	{

	  int result  = chooser.showSaveDialog(parent);

	  if (result == JFileChooser.APPROVE_OPTION)
	   {

		try
		 {

		  String fileVal=chooser.getSelectedFile().getPath();

		  if(fileVal.substring(fileVal.length()-4,fileVal.length()-3).equals("."))
		  {
			  if(!fileVal.substring(fileVal.length()-3,fileVal.length()).equals("csv"))
			   {
			     JOptionPane.showMessageDialog(new ErrorFrame(), "OACoder only exports results in csv files.", "Error Message",JOptionPane.ERROR_MESSAGE);
		       }
			  else
			   {
			      fileField.setText(fileVal);
			   }

		  }
		  else
		  {

		      fileVal+=".csv";
		      fileField.setText(fileVal);
		  }

	     }//end of try
	     catch(Exception e)
	     {
          JOptionPane.showMessageDialog(new ErrorFrame(), "An error has occured, please select the file again.", "Error Message",JOptionPane.ERROR_MESSAGE);
		 }//end of catch

	   }

	}


    public void goToNextPanel()
    {
        if ((fileField.getText()).equals(""))
        {
            JOptionPane.showMessageDialog(new ErrorFrame(), "You must select a csv file to export, before you proceed.", "Error Message",
                    JOptionPane.ERROR_MESSAGE);
        }
        else
        {

 		 filePath = fileField.getText();
		 removeAll();
		 validate();
		 parent.getContentPane().removeAll();
		 parent.add(BorderLayout.NORTH,new LogoPanel("images/logo.bmp"));

		 boolean writeScore = false;
         boolean writeCases = false;

         indexVal=comboBoxes[0].getSelectedIndex();
         parent.setSize(500,420);
		 parent.getContentPane().add(new ProgressBarPanel(parent,readFiles, fileName, fiftyRecords, fileHeaders,filePath, columnNr, indexes, exportedCels,writeScore, writeCases));
         parent.validate();


        }
    }

    public int[] getIndexes(String[] inputHeaders)
    {
        int[] indexes = new int[NR_IMPORT_FIELDS];

        for (int i = 0; i < indexes.length; i++)
        {
            indexes[i] = -1;
        }

        for (int i = inputHeaders.length - 1; i >= 0; i--)
        {
            if ((inputHeaders[i].toLowerCase().indexOf("id") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("nr") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("#") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("post") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("Post") > -1))
            {
                indexes[0] = i;
            }
            else if ((inputHeaders[i].toLowerCase().indexOf("sur") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("last") > -1))
            {
                indexes[1] = i;
            }
            else if ((inputHeaders[i].toLowerCase().indexOf("fore") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("christian") > -1)
                    || (inputHeaders[i].toLowerCase().indexOf("first") > -1))
            {
                indexes[2] = i;
            }

        }

        return indexes;
    }


   /////Filter
   public class TextFileFilter extends javax.swing.filechooser.FileFilter
    {
      public boolean accept(File file)
      {
        return (file.getName().toLowerCase().endsWith(".csv")  || file.isDirectory());
      }

      public String getDescription()
      {
        return "CSV File (*.csv)";
      }
    }


}
