import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import java.awt.GridBagLayout;
import java.awt.BorderLayout;
import java.awt.image.BufferedImage;
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Insets;
import java.awt.Dimension;
import javax.swing.JButton;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.BorderFactory;
import javax.imageio.ImageIO;
import java.io.File;
import java.io.IOException;

/**
 * A panel which is used to show the logo in OACoder
 */

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class LogoPanel extends JPanel
{

	private static final long serialVersionUID = 10023;

    private ImageIcon logo;

    public LogoPanel(String logoPath)
    {
        setBorder(BorderFactory.createEmptyBorder(20,10,10,10));
        setOpaque(true);
        setBackground(Color.WHITE);
        setLayout(new GridBagLayout());
        setFocusable(false);

        try
        {
            File bmpImageFile = new File(logoPath);
            BufferedImage bi = ImageIO.read(bmpImageFile);
            logo = new ImageIcon(bi);
            JButton logoButton = new JButton(logo)
            {
				private static final long serialVersionUID = 10029;
                public Dimension getPreferredSize()
                {
                    return getSize();
                }
            };

            logoButton.setFocusable(false);
            logoButton.setSize(logo.getIconWidth(), logo.getIconHeight());
            logoButton.setMargin(new Insets(0, 0, 0, 0));

            add(logoButton);
        } catch (IOException e) {}
    }


    public LogoPanel(String logoPath, String position, String htmlFile)
    {
        setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
        setOpaque(true);
        setBackground(Color.WHITE);
        setLayout(new BorderLayout());

        try
        {
            File bmpImageFile = new File(logoPath);
            BufferedImage bi = ImageIO.read(bmpImageFile);
            logo = new ImageIcon(bi);

            JButton logoButton = new JButton(logo)
            {
				private static final long serialVersionUID = 10030;
                public Dimension getPreferredSize()
                {
                    return getSize();
                }
            };

            logoButton.setFocusable(false);
            logoButton.setSize(logo.getIconWidth(), logo.getIconHeight());
            logoButton.setMargin(new Insets(0, 0, 0, 0));
            add(position, logoButton);

        } catch (IOException e) {}
    }

}
