import javax.swing.JPanel;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.ImageIcon;
import java.awt.Component;
import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

/**
 * A panel to show the first 50 records of the users' input file
 * Could be extended to show any number of records
*/

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class ProcessTablePanel extends JPanel
{

	private static final long serialVersionUID = 10026;

    /**  */
    private ImageIcon helpIcon;

    /**  */
    private int xPos;

    /**  */
    private Screen parent;

    /**  */
    private int yPos;


    /**  */
    private Box helpRow;

    /**  */
    public static final int ALIGNMENT = 10;

    /**  */
    private static int nrTablePanel = 0;

    /**  */
    private ReadFile rf;

    /**  */
    private String fileName;

    /**  */
    private String[] fileHeaders;

    /**  */
    private String[][] fiftyRecords;

    /**
     *
     */
    public ProcessTablePanel(Screen parent, ReadFile rf, String fileName,String[][] fiftyRecords, String[] fileHeaders)
    {

        nrTablePanel++;
        this.parent = parent;
        this.rf = rf;
        this.fileName = fileName;
        this.fileHeaders = fileHeaders;
        this.fiftyRecords = fiftyRecords;

        if(fileHeaders == null)
        {
            System.out.println("ok");
        }

        if(fiftyRecords == null)
        {
            System.out.println("ok2");
        }

        setOpaque(true);
        setBackground(Color.WHITE);
        setLayout(new BoxLayout(ProcessTablePanel.this, BoxLayout.PAGE_AXIS));

        parent.setSize(600,500);

        Box rowZero = Box.createHorizontalBox();
        JLabel mainLabel = new JLabel("Input File                                                  ");
        mainLabel.setFont(new Font("SansSerif", Font.BOLD, 20));
        rowZero.add(mainLabel);
        rowZero.setAlignmentX(Component.CENTER_ALIGNMENT);
        rowZero.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));

        Box rowOne = Box.createHorizontalBox();

        JPanel recordsLine = new JPanel();
        recordsLine.setOpaque(true);
        recordsLine.setBackground(Color.WHITE);
        String s = "" + ReadUserFile.getTarget() + "";
        JLabel records = new JLabel(s);
        records.setFont(new Font("SansSerif", Font.BOLD, 12));

        recordsLine.add(new JLabel("The input file contains a total of: "));
        recordsLine.add(records);
        recordsLine.add(new JLabel(" records."));

        JLabel info2Label = new JLabel("The first 50 records of the input" +
                " file are shown here for reference purposes.");
        JLabel info3Label = new JLabel("The first line of your input file will be assumed to" +
                " contain the column names.");

        JPanel hyperlinksPanel = new JPanel();
        hyperlinksPanel.setOpaque(true);
        hyperlinksPanel.setBackground(Color.WHITE);


        JPanel infoLabel = new JPanel();
        infoLabel.setLayout(new GridBagLayout());
        infoLabel.setOpaque(true);
        infoLabel.setBackground(Color.WHITE);

        infoLabel.add(recordsLine,new GBC(0, 0).setAnchor(GridBagConstraints.WEST).setInsets(0));
        infoLabel.add(info2Label,new GBC(0, 1).setAnchor(GridBagConstraints.WEST).setInsets(0, 5, 5, 0));
        infoLabel.add(info3Label,new GBC(0, 2).setAnchor(GridBagConstraints.WEST).setInsets(0, 5, 0, 0));
        infoLabel.add(hyperlinksPanel,new GBC(0, 3).setAnchor(GridBagConstraints.WEST).setInsets(0, 0, 0, 0));

        rowOne.setBorder(BorderFactory.createEmptyBorder(0, 5, 10, 10));
        rowOne.setAlignmentX(Component.RIGHT_ALIGNMENT);
        rowOne.add(infoLabel);

        Box rowThree = Box.createHorizontalBox();
        final JTable table = new JTable(fiftyRecords, fileHeaders);

        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);
        table.setAutoscrolls(true);
        scrollPane.setAlignmentX(Component.RIGHT_ALIGNMENT);

        //Add the scroll pane to the box.
        rowThree.add(scrollPane);
        rowThree.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

        Box rowFour = Box.createHorizontalBox();
        JPanel buttonPanel = new JPanel();
        buttonPanel.setOpaque(true);
        buttonPanel.setBackground(Color.WHITE);
        buttonPanel.setLayout(new GridBagLayout());

        JButton button = new JButton("Next >>");
        ActionListener process = new ProcessListener();
        button.addActionListener(process);

        buttonPanel.add(button, new GBC(2, 0).setInsets(10, 20, 10, 10));
        buttonPanel.add(new JLabel(""), new GBC(3, 0).setInsets(20));
        rowFour.add(buttonPanel);

        add(rowZero);
        add(Box.createVerticalGlue());
        add(rowOne);
        add(Box.createVerticalGlue());
        add(rowThree);
        add(Box.createVerticalGlue());
        add(rowFour);
    }

    public void goToNextPanel()
    {
        int recordsAllowed = 10000000;
        int nrRecords = ReadUserFile.getTarget();

        removeAll();
        validate();
        parent.getContentPane().removeAll();
        parent.add("North", new LogoPanel("images/logo.bmp"));
        parent.getContentPane().add(new IdentificationPanel(parent, rf,fileName, fiftyRecords, fileHeaders));
        parent.setSize(500,420);
        parent.centerFrame();
        parent.validate();
    }


    private class ProcessListener implements ActionListener
    {

        public void actionPerformed(ActionEvent evt)
        {
            goToNextPanel();
        }
    }


}
