import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.File;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.io.FileReader;
import java.io.LineNumberReader;

/**
* A class to read users' input file
*/

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class ReadUserFile
{
    private String fileName;
    private String[] fileHeaders;
    private FileInputStream fis;
    private BufferedReader br;
    private String[][] firstFiftyRecords;
    public static final int NR_DISPLAY_RECORDS = 50;
    private int nrOfDisplayColumns;
    private static int target = 0;

    public ReadUserFile(String fileName)throws IOException
    {
        this.fileName = fileName;
        nrOfDisplayColumns = 0;
    }

    public static int getTarget()
    {
        return target;
    }

    public void read() throws IOException
    {
        fis = new FileInputStream(new File(fileName));
        br = new BufferedReader(new InputStreamReader(fis));
        String temp = "";
        String[] ret = null;
        fileHeaders = new CommaDivision(br.readLine()).getLineParts();
        nrOfDisplayColumns = fileHeaders.length;
        firstFiftyRecords = new String[NR_DISPLAY_RECORDS][nrOfDisplayColumns];
        int counter = 0;

        while (counter < NR_DISPLAY_RECORDS && (temp = br.readLine()) != null) {
            if (temp.equals("")) {
                continue;
            } else {
                ret = new CommaDivision(temp).getLineParts();
                if (counter < NR_DISPLAY_RECORDS) {
                    for (int j = 0; j < nrOfDisplayColumns; j++) {
                        firstFiftyRecords[counter][j] = ret[j];
                    }
                    counter++;
                }
            }
        }
        br.close();
    }


    public String getFileName()
    {
        return fileName;
    }

    public String[] getFileHeaders()
    {
        return fileHeaders;
    }

    public String[][] getFirstFiftyRecords()
    {
        return firstFiftyRecords;
    }

}
