import java.awt.Toolkit;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.ImageIcon;
import javax.swing.ImageIcon;
import javax.imageio.ImageIO;
import java.io.File;
import java.io.IOException;

/*
* A generic layout of the OACoder
*/

/**
 * AUTHOR: MUHAMMAD ADNAN
 * LICENSE: GNU General Public License, version 3 (GPL-3.0)
*/

public class Screen extends JFrame
{

	private static final long serialVersionUID = 10021;

    /**  */
    public static final int WIDTH = 600;

    /**  */
    public static final int HEIGHT = 600;

    /**  */
    public static final int BIG_SCREEN_WIDTH = 800;

    /** */
    public static final int BIG_SCREEN_HEIGHT = 900;

    /**  */
    public static final int STATISTICS_WIDTH = 1000;

    /**  */
    public static final int STATISTICS_HEIGHT = 1000;

    /**  */
    public static final String TITLE = "Public Profiler - OACoder";


    public Screen()
    {
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch(Exception e)
        {}

        setSize(WIDTH, HEIGHT);
        setTitle(TITLE);
        centerFrame();

        try
        {
            File bmpImageFile = new File("images/smallLogo.bmp");
            BufferedImage bi = ImageIO.read(bmpImageFile);
            ImageIcon logo = new ImageIcon(bi);

            this.setIconImage(logo.getImage());
        }
        catch (IOException e)
        {
	    }

        addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
        });
    }


    public void centerFrame()
    {
        //The toolkit will get information on system.
        Toolkit tk = Toolkit.getDefaultToolkit();
        // Get the screen dimensions.
        Dimension screen = tk.getScreenSize();

        // And place it in center of screen.
        int x = (int) ((screen.getWidth() - this.getWidth()) / 2);
        int y = (int) ((screen.getHeight() - this.getHeight()) / 2);

        setLocation(x, y);
    }
}
